package Storage;

import java.io.Serializable;
import java.util.Vector;

/**
 * TODO: document.
 *
 * @author serguei
 * @since May 29, 2010
 * @version $Id: FileItem.java,v 1.12 2011/01/14 00:31:30 mokhov Exp $
 */
public class FileItem
implements Serializable
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -8914896563824794060L;
	
	private String strFileID = "-1";
	private String strPath = "[Unknown Path]";
	private String strFileType = "[Unset file type]";
	private String strIgnore = "false";

	private String strLines = "-1";
	private String strWords = "-1";
	private String strBytes = "-1";
	
	/**
	 * Can have multiple locations.
	 */
	private Vector<MetaLocation> oLocations = new Vector<MetaLocation>(); 

	/**
	 * Indicates whether any of the essential components of
	 * the item were set or not. 
	 */
	private Boolean bEmpty = true;

	
	/**
	 * 
	 */
	public FileItem()
	{
		// TODO Auto-generated constructor stub
	}

	public Boolean isEmpty()
	{
		return this.bEmpty;
	}

	public Boolean isLocationless()
	{
		return
			this.bEmpty
			|| this.oLocations == null
			|| this.oLocations.size() == 0;
	}
	
	/**
	 * Allows querying for TODO.
	 * @return returns the value strArticleID field.
	 */
	public String getFileID()
	{
		return this.strFileID;
	}


	/**
	 * Allows setting TODO.
	 * @param pstrFileID the new value of strArticleID to set.
	 */
	public void setFileID(String pstrFileID)
	{
		this.strFileID = pstrFileID;
		this.bEmpty = false;
	}


	/**
	 * Allows querying for TODO.
	 * @return returns the value strGeoLocation field.
	 */
	public String getPath()
	{
		return strPath;
	}

	/**
	 * Allows setting TODO.
	 * @param pstrPath the new value of strGeoLocation to set.
	 */
	public void setPath(String pstrPath)
	{
		this.strPath = pstrPath;
		this.bEmpty = false;
	}

	/**
	 * Allows querying for TODO.
	 * @return returns the value strCategory field.
	 */
	public String getFileType()
	{
		return this.strFileType;
	}

	/**
	 * Allows setting TODO.
	 * @param pstrFileType the new value of strCategory to set.
	 */
	public void setFileType(String pstrFileType)
	{
		this.strFileType = pstrFileType;
		this.bEmpty = false;
	}

	/**
	 * Allows querying for TODO.
	 * @return returns the value strCategory field.
	 */
	public String getIgnore()
	{
		return this.strIgnore;
	}

	/**
	 * Allows setting TODO.
	 * @param pstrFileType the new value of strCategory to set.
	 */
	public void setIgnore(String pstrIgnore)
	{
		this.strIgnore = pstrIgnore;
		this.bEmpty = false;
	}
	
	/**
	 * A helper method around the 'ignore' attribute for the applications
	 * to check if they are to ignore this file item entry. 
	 * @return true if this file item is to be ignored
	 */
	public Boolean isToIgnore()
	{
		return "true".equals(this.strIgnore.toLowerCase());
	}
	
	public String getLines()
	{
		return strLines;
	}

	public void setLines(String strLines)
	{
		this.strLines = strLines;
	}

	public String getWords()
	{
		return strWords;
	}

	public void setWords(String pstrWords)
	{
		this.strWords = pstrWords;
	}

	public String getBytes()
	{
		return strBytes;
	}

	public void setBytes(String pstrBytes)
	{
		this.strBytes = pstrBytes;
	}

	
	public boolean addLocation(MetaLocation poLocation)
	{
		this.bEmpty = false;
		return this.oLocations.add(poLocation);
	}

	public boolean addLocations(Vector<MetaLocation> poLocations)
	{
		this.bEmpty = false;
		return this.oLocations.addAll(poLocations);
	}
	
	
	/**
	 * Allows querying for TODO.
	 * @return returns the value oLocations field.
	 */
	public Vector<MetaLocation> getLocations()
	{
		return this.oLocations;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		String strItem = 
		
			"strFileID: [" + this.strFileID + "]\n"
			+ "strPath: [" + this.strPath + "]\n"
			+ "strFileType: [" + this.strFileType + "]\n"
			+ "bEmpty: [" + this.bEmpty + "]\n"
			+ "oLocations: [[" + this.oLocations + "]]\n"
		;
		
		return strItem;
	}
}

// EOF
