package Storage;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;

import marf.Storage.StorageException;

/**
 * @author serguei
 * @since September 1, 2010
 */
public class LineContextReader
{
	//public static final Integer DEFAULT_CONTEXT_BEFORE_IN_LINES = 5;
	//public static final Integer DEFAULT_CONTEXT_AFTER_IN_LINES = 5;
	public static final Integer DEFAULT_CONTEXT_BEFORE_IN_LINES = 10;
	public static final Integer DEFAULT_CONTEXT_AFTER_IN_LINES = 10;

	protected Integer iTargetLineNumber = 0;
	protected Integer iFragmentLines = 1;
	
	
	protected BufferedReader oReader = null;
	
	
	public LineContextReader(String pstrFilename, Integer piLineNumber, Integer piFragmentLines)
	throws StorageException
	{
		try
		{
			this.oReader = new BufferedReader(new FileReader(new File(pstrFilename)));
			this.iTargetLineNumber = piLineNumber;
			this.iFragmentLines = piFragmentLines;
		}
		catch(Exception e)
		{
			throw new StorageException(e);
		}
	}
	
	/**
	 * 
	 */
	public LineContextReader(String pstrFilename, Integer piLineNumber)
	throws StorageException
	{
		this(pstrFilename, piLineNumber, 1);
	}

	public String getFragmentWithContext()
	//throws IOException
	throws StorageException
	{
		try
		{
			StringBuffer oBuffer = new StringBuffer();
			
			Integer iStartLine = this.iTargetLineNumber - DEFAULT_CONTEXT_BEFORE_IN_LINES;
			
			if(iStartLine <= 0)
			{
				iStartLine = 1;
			}
	
			// The upper line limit, if crosses the EOF, will be
			// detected as such during the actual reading as we don't know
			// the line count in advance. (In theory we _could_ learn the
			// total line count from FileItems that have it initialized from
			// the meta XML file, but it's not guaranteed they always have it.
			Integer iEndLine = this.iTargetLineNumber + (this.iFragmentLines - 1) + DEFAULT_CONTEXT_AFTER_IN_LINES;
			
			String strLine = "";
			Integer iCurrentLine = 0;
			
			while((strLine = this.oReader.readLine()) != null && iCurrentLine < iEndLine)
			{
				iCurrentLine++;
				
				if(iCurrentLine >= iStartLine && iCurrentLine <= iEndLine)
				{
					//XXX
					//if(iCurrentLine == this.iTargetLineNumber)
					//{
					//	oBuffer.append(this.iTargetLineNumber).append(": ");
					//}
					
					oBuffer
						.append(iCurrentLine).append(": ")
						.append(strLine)
						.append("\n");
				}
			}
			
			this.oReader.close();
			
			return oBuffer.toString();
		}
		catch(Exception e)
		{
			throw new StorageException(e);
		}
	}
}

// EOF
