package Storage;

import java.io.Serializable;
import java.util.Vector;


/**
 * TODO: document.
 *
 *
 * $Id: MetaLocation.java,v 1.8 2010/09/11 18:48:53 mokhov Exp $
 *
 * @author serguei
 * @since Aug 7, 2010
 */
public class MetaLocation
implements Serializable
{
	//private String strCVE = "[Unknown CVE]";
	private Vector<String> oCVEs = new Vector<String>();
	
	private boolean bEmpty = true;
	
	private Vector<CWE> oCWEs = new Vector<CWE>();
	
	public static String DEFAULT_EXPLANATION = "[Unset explanation]";
	public static String DEFAULT_CODE_FRAGMENT = "[Unset code fragment.]";
	
	private String strLineNumber = "0";
	
	private String strCodeFragment = DEFAULT_CODE_FRAGMENT; 
	private String strExplanation = DEFAULT_EXPLANATION;
	
	private String strFragmentLines = "0"; 

	private String strIgnore = "false";

	// "path", "sink", "fix"
	private String strType = "sink (default)";
	
	
	public MetaLocation()
	{
		
	}
	
	
	public boolean addCVE(String pstrCVE)
	{
		this.bEmpty = false;
		return this.oCVEs.add(pstrCVE);
	}
	
	public boolean addCVEs(Vector<String> poCVEs)
	{
		this.bEmpty = false;
		return this.oCVEs.addAll(poCVEs);
	}
	
	public boolean addCWE(CWE poCWE)
	{
		this.bEmpty = false;
		return this.oCWEs.add(poCWE);
	}

	public boolean addCWEs(Vector<CWE> poCWEs)
	{
		this.bEmpty = false;
		return this.oCWEs.addAll(poCWEs);
	}

	public boolean addCWE(String pstrName, String pstrCWEID)
	{
		this.bEmpty = false;
		return this.oCWEs.add(new CWE(pstrName, pstrCWEID));
	}

	/**
	 * @param pstrSubject CVE or SWE string
	 * @return
	 */
	public Boolean containsSubject(String pstrSubject)
	{
		if(this.oCVEs.contains(pstrSubject) == true)
		{
			return true;
		}
		
		for(CWE oCWE: this.oCWEs)
		{
			if(oCWE.getCWEID().equals(pstrSubject))
			{
				return true;
			}
		}
		
		return false;
	}
	
	public String getLineNumber()
	{
		return strLineNumber;
	}

	public void setLineNumber(String strLineNumber)
	{
		this.strLineNumber = strLineNumber;
		this.bEmpty = false;
	}

	public String getFragmentLines()
	{
		return strFragmentLines;
	}

	public void setFragmentLines(String pstrFragmentLines)
	{
		this.strFragmentLines = pstrFragmentLines;
		this.bEmpty = false;
	}

	public String getCodeFragment()
	{
		return strCodeFragment;
	}

	public void setCodeFragment(String strCodeFragment)
	{
		this.strCodeFragment = strCodeFragment;
		this.bEmpty = false;
	}

	public String getExplanation()
	{
		return strExplanation;
	}

	public void setExplanation(String strExplanation)
	{
		this.strExplanation = strExplanation;
		this.bEmpty = false;
	}

	public Vector<String> getCVEs()
	{
		return oCVEs;
	}

	public Vector<CWE> getCWEs()
	{
		return oCWEs;
	}
	
	public boolean isEmpty()
	{
		return this.bEmpty;
	}

	public String getIgnore()
	{
		return this.strIgnore;
	}

	public void setIgnore(String pstrIgnore)
	{
		this.strIgnore = pstrIgnore;
	}
	
	/**
	 * A helper method around the 'ignore' attribute for the applications
	 * to check if they are to ignore this meta location entry. 
	 * @return true if this meta location is to be ignored
	 */
	public Boolean isToIgnore()
	{
		try
		{
			return "true".equals(this.strIgnore.toLowerCase());
		}
		catch(Exception e)
		{
			return false;
		}
	}

	/**
	 * Allows querying for TODO.
	 * @return returns the value strType field.
	 */
	public String getType()
	{
		return this.strType;
	}

	/**
	 * Allows setting TODO.
	 * @param strType the new value of strType to set.
	 */
	public void setType(String strType)
	{
		this.strType = strType;
	}


	/* (non-Javadoc)
	 * @see java.lang.Object#toString()
	 */
	@Override
	public String toString()
	{
		String strMetaLocation =
			"<<strLineNumber:" + this.strLineNumber + ",,,\n"
			+ "  oCVEs:" + this.oCVEs + ",,,\n"
			+ "  oCWEs:" + this.oCWEs + ",,,\n"
			+ "  strExplanation:" + this.strExplanation + ",,,\n"
			+ "  strCodeFragment:" + this.strCodeFragment + ",,,\n"
			+ "  strType:" + this.strType + ",,,\n"
			+ "  strIgnore:" + this.strIgnore + ",,,\n"
			+ "  bEmpty:" + this.bEmpty + "\n"
			+ "/>>\n"
			;
		
		return strMetaLocation;
	}
}

// EOF
